using System;
using System.Data;
using System.Windows.Forms;
using System.Collections.Generic;
using System.Text;
using Syncfusion.Windows.Forms.Tools;

namespace TargetChanging {
    public class AutoCompleteTextBox:TextBox { 
        private AutoComplete _autoComplete;

        public AutoCompleteTextBox()
            : base() {
            this._autoComplete = new AutoComplete();
            ((System.ComponentModel.ISupportInitialize)(this._autoComplete)).BeginInit();
            this._autoComplete.AccessibleDescription = null;
            this._autoComplete.AccessibleName = null;
            this._autoComplete.AccessibleRole = System.Windows.Forms.AccessibleRole.None;
            this._autoComplete.AdjustHeightToItemCount = true;
            this._autoComplete.AutoAddItem = false;
            this._autoComplete.AutoSerialize = true;
            this._autoComplete.CategoryName = "";
            this._autoComplete.ParentForm = this.Parent;
            this._autoComplete.ShowColumnHeader=false;
            this._autoComplete.PreferredHeight = 300;
            this._autoComplete.PreferredWidth = 200;
            this._autoComplete.SelectedIndex = -1;
            this._autoComplete.SelectedValue = "";
            this._autoComplete.ShowCloseButton = false;
            this._autoComplete.ShowGripper = false;
            this._autoComplete.ActiveFocusControl = this;
            this._autoComplete.SetAutoComplete(this,AutoCompleteModes.AutoSuggest);
            ((System.ComponentModel.ISupportInitialize)(this._autoComplete)).EndInit();
            this.BorderStyle = System.Windows.Forms.BorderStyle.None;
            this.Font = new System.Drawing.Font("Arial",8.25F,System.Drawing.FontStyle.Regular,System.Drawing.GraphicsUnit.Point,((byte)(0)));
            this._autoComplete.TargetChanging += new AutoCompleteTargetChangingEventHandler(_autoComplete_TargetChanging);
        }

        /// <summary>
        /// Here this event should not be fired once and it lost himself in an infinite 
        /// cascading event loop
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="args"></param>
        void _autoComplete_TargetChanging(object sender,AutoCompleteTargetChangingEventArgs args) {
            MessageBox.Show("How Can I Change Target when I am only associated to one textbox");
        }

        public void SetTableData(DataTable table) {
            this._autoComplete.DataSource = table;
            this._autoComplete.SetTableData();
        }

        public void ShowAutoComplete() {
            this._autoComplete.ProcessAutoComplete(this.Text);
        }

        public void SetTableData( string[] choices) {
            DataTable table = new DataTable("table");
            table.Columns.Add("name",typeof(string));
            foreach(string choice in choices) {
                table.Rows.Add(new object[] { choice});
            }
            this.SetTableData(table);
        }
    }
}
